// A simple linear-search dictionary implemented as a linked list.

#include "dict.h"
#include <string.h>
#include <stdlib.h>
#include "llist.h"
#include <iostream.h>
#include "trace.h"

char *
llist::operator[] (char *key) {
	llist_listnode *curp = this->list;
	while (curp != (llist_listnode*)NULL) {

		trace("Trying a node with the key ");
		trace(curp->key);
		trace(endl);

		if (strcmp(key, curp->key) == 0) {
			return curp->data;
		}
		curp = curp->next;
	}

	trace("Couldn't find a node for the key ");
	trace(key);
	trace(endl);

	return (char*)NULL;
}

int 
llist::ins (char *key, char *data) {
	// In error conditions, the new operator or the constructor
	// will throw an exception, preventing this->list from being
	// nuked.
	this->list = new llist_listnode (key, data, this->list);
}
