// A linked-list implementation of a dict.
// Requires string.h and something declaring malloc, like malloc.h or stdlib.h

// It would be nice to implement llist as a listnode itself.  Unfortunately,
// that would make it impossible to have an llist with zero elements.  In
// keeping with the famous zero, one, or any-number-from-zero-to-infinity
// rule, I decided it would be much more pleasant to be able to have zero
// elements.

class llist_listnode {
public: // bad form, I know
	char *key;
	char *data;
	llist_listnode *next;
	llist_listnode(char *nkey, char *ndata, llist_listnode *nnext) { 
		key=strdup(nkey); data=strdup(ndata); next=nnext;
		if ( !(key && data) ) { throw "Allocation failure"; }
	}
	~llist_listnode() { free(key); free(data); }
};

class llist: public dict {
	llist_listnode *list;
public:
        virtual char *operator[](char *key);
        virtual int ins(char *key, char *data);

	llist() { 
		list = (llist_listnode*) NULL;
	}
};
